// GeneralSetting.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "offlinepnger.h"
#include "GeneralSetting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGeneralSetting _CAO


CGeneralSetting::CGeneralSetting(CWnd* pParent /*=NULL*/)
	: CDialog(CGeneralSetting::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGeneralSetting)
	m_bWidthStatic = FALSE;
	m_bSpace = FALSE;
	m_uiMargin = 0;
	m_uiWidthStatic = 0;
	m_uiWidthMax = 0;
	m_uiRowHeight = 0;
	m_uiHeightMax = 0;
	m_bConfirm = FALSE;
	//}}AFX_DATA_INIT
}


void CGeneralSetting::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeneralSetting)
	DDX_Control(pDX, IDC_HEIGHT_MAX, m_editHeightMax);
	DDX_Control(pDX, IDC_HEIGHT_MAX_UNIT, m_LabelHeightMaxUnit);
	DDX_Control(pDX, IDC_HEIGHT_MAX_LABEL, m_LabelHeightMax);
	DDX_Check(pDX, IDC_WIDTH_STATIC, m_bWidthStatic);
	DDX_Control(pDX, IDC_WIDTH_MAX, m_editWidthMax);
	DDX_Control(pDX, IDC_WIDTH_MAX_LABEL, m_LabelWidthMax);
	DDX_Control(pDX, IDC_WIDTH_MAX_UNIT, m_LabelWidthMaxUnit);
	DDX_Control(pDX, IDC_WIDTH_STATIC_VALUE_UNIT, m_LabelWidthStaticUnit);
	DDX_Control(pDX, IDC_WIDTH_STATIC_VALUE, m_editWidthStatic);
	DDX_Control(pDX, IDC_COLOR_BACK, m_Back);
	DDX_Control(pDX, IDC_COLOR_FORE, m_Fore);
	DDX_Check(pDX, IDC_SPACE_EMULATION, m_bSpace);
	DDX_Text(pDX, IDC_MARGIN, m_uiMargin);
	DDV_MinMaxUInt(pDX, m_uiMargin, 0, 100);
	DDX_Text(pDX, IDC_WIDTH_STATIC_VALUE, m_uiWidthStatic);
	DDX_Text(pDX, IDC_WIDTH_MAX, m_uiWidthMax);
	DDX_Text(pDX, IDC_ROW_HEIGHT, m_uiRowHeight);
	DDX_Text(pDX, IDC_HEIGHT_MAX, m_uiHeightMax);
	DDX_Check(pDX, IDC_COMFIRM, m_bConfirm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGeneralSetting, CDialog)
	//{{AFX_MSG_MAP(CGeneralSetting)
	ON_BN_CLICKED(IDC_COLOR_FORE, OnColorFore)
	ON_BN_CLICKED(IDC_COLOR_BACK, OnColorBack)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_WIDTH_STATIC, OnWidthStatic)
	ON_BN_CLICKED(IDC_COMFIRM, OnComfirm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeneralSetting bZ[W nh

/*-----------------------------------------------------------------------------
[]	FNbNnh
[@\]	F̐ݒsB
[ߒl]	Ȃ
[l]	_uNbNnh R[B
-----------------------------------------------------------------------------*/
void CGeneralSetting::OnColorFore() 
{
	CColorDialog	dlg;
	if( dlg.DoModal() == IDOK )
	{
		m_colFore = dlg.GetColor();
		RedrawWindow();
	}
}


/*-----------------------------------------------------------------------------
[]	wiFNbNnh
[@\]	wiF̐ݒsB
[ߒl]	Ȃ
[l]	_uNbNnh R[B
-----------------------------------------------------------------------------*/
void CGeneralSetting::OnColorBack() 
{
	CColorDialog	dlg;
	if( dlg.DoModal() == IDOK )
	{
		m_colBack = dlg.GetColor();
		RedrawWindow();
	}
}


/*-----------------------------------------------------------------------------
[]	NbNnh
[@\]	F{̏ŃNbNꂽFݒ֍sB
[ߒl]	WM_LBUTTONDOWN nh̃wvQƁB
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CGeneralSetting::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// F̏ŃNbNꂽH
	{
		CRect	rc;
		m_Fore.GetWindowRect( &rc );
		CPoint	pt( rc.left, rc.top );
		ScreenToClient( &pt );
		rc.right = rc.Width();
		rc.bottom = rc.Height();
		rc.left = pt.x;
		rc.top = pt.y;
		rc.right += pt.x;
		rc.bottom += pt.y;

		if( rc.left <= point.x )
		if( rc.right >= point.x )
		if( rc.top <= point.y )
		if( rc.bottom >= point.y )
		{
			// Fݒ
			OnColorFore();
		}
	}

	// wiF̏ŃNbNꂽH
	{
		CRect	rc;
		m_Back.GetWindowRect( &rc );
		CPoint	pt( rc.left, rc.top );
		ScreenToClient( &pt );
		rc.right = rc.Width();
		rc.bottom = rc.Height();
		rc.left = pt.x;
		rc.top = pt.y;
		rc.right += pt.x;
		rc.bottom += pt.y;

		if( rc.left <= point.x )
		if( rc.right >= point.x )
		if( rc.top <= point.y )
		if( rc.bottom >= point.y )
		{
			// wiFݒ
			OnColorBack();
		}
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CGeneralSetting::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg

	// F{ F
	{
		CRect	rc;
		m_Fore.GetWindowRect( &rc );
		CPoint	pt( rc.left, rc.top );
		ScreenToClient( &pt );
		rc.right = rc.Width();
		rc.bottom = rc.Height();
		rc.left = pt.x;
		rc.top = pt.y;
		rc.right += pt.x;
		rc.bottom += pt.y;
		dc.FillSolidRect(
			&rc,
			m_colFore
		);
	}

	// F{ wiF
	{
		CRect	rc;
		m_Back.GetWindowRect( &rc );
		CPoint	pt( rc.left, rc.top );
		ScreenToClient( &pt );
		rc.right = rc.Width();
		rc.bottom = rc.Height();
		rc.left = pt.x;
		rc.top = pt.y;
		rc.right += pt.x;
		rc.bottom += pt.y;
		dc.FillSolidRect(
			&rc,
			m_colBack
		);
	}
}

BOOL CGeneralSetting::OnInitDialog() 
{
	CDialog::OnInitDialog();
	UpdateData( FALSE );
	VisibleControl();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


void CGeneralSetting::OnDefault() 
{
	m_colFore = DEFAULT_COL_FORE;
	m_colBack = DEFAULT_COL_BACK;
	m_uiMargin = DEFAULT_MARGIN;
	m_uiRowHeight = DEFAULT_ROW_HEIGHT;
	m_bSpace = DEFAULT_SPACE;
	m_bWidthStatic = DEFAULT_WIDTH_STATIC_ENABLE;
	m_uiWidthStatic = DEFAULT_WIDTH_STATIC;
	m_bConfirm = FALSE;
	m_uiWidthMax = DEFAULT_WIDTH_MAX;
	m_uiHeightMax = DEFAULT_HEIGHT_MAX;

	UpdateData( FALSE );
	VisibleControl();
	RedrawWindow();
}

void CGeneralSetting::OnWidthStatic() 
{
	UpdateData( TRUE );
	VisibleControl();
}

void CGeneralSetting::VisibleControl()
{
//	m_bWidthStatic.EnableWindow( m_bWidthStatic );
	m_editWidthStatic.EnableWindow( m_bWidthStatic );
	m_LabelWidthStaticUnit.EnableWindow( m_bWidthStatic );


	m_LabelWidthMax.EnableWindow( m_bConfirm );
	m_editWidthMax.EnableWindow( m_bConfirm );
	m_LabelWidthMaxUnit.EnableWindow( m_bConfirm );
	m_LabelHeightMax.EnableWindow( m_bConfirm );
	m_editHeightMax.EnableWindow( m_bConfirm );
	m_LabelHeightMaxUnit.EnableWindow( m_bConfirm );
}

void CGeneralSetting::OnComfirm() 
{
	UpdateData( TRUE );

	if ( !m_bConfirm )
	{
		m_uiWidthMax = DEFAULT_WIDTH_MAX;
		m_uiHeightMax = DEFAULT_HEIGHT_MAX;
		UpdateData( FALSE );
	}

	VisibleControl();
}
